/**********************************************************************
SQL Server Internals from the Practical Angle

Dmitri Korotkevitch
http://aboutsqlserver.com
dmitri@aboutsqlserver.com

Locking and Blocking: RCSI (Session 1)
**********************************************************************/

use TroubleshootingDb
go

set nocount on
go

-- We don't need to set TIL to read uncommitted here
-- behavior of (X) lock does not depend on it
set transaction isolation level read uncommitted
begin tran
	update dbo.SmallRow set CharField = 'a' where ID = 100
	select * from sys.dm_tran_locks where request_session_id = @@SPID
	-- Run session 2 code
rollback
go

alter database TroubleshootingDb set read_committed_snapshot on with rollback immediate
go


alter database TroubleshootingDb set read_committed_snapshot off with rollback immediate
go
